/* subalign.c -- print a range of columns from a "refine" output, as indexed by
*  positions in the reference sequence.
*/

#include "util.h"
#include "read_malign.h"

int main( int argc, char **argv)
{
	int f, t, from, to, i, j, k, nrow, ncol;
	char **seq_name, **A;

	if (argc != 4)
		fatal("args: multiple-alignment-file from to");

	A = read_malign(argv[1], &nrow, &ncol, &seq_name);
	f = atoi(argv[2]);
	t = atoi(argv[3]);
	if (f > t)
		fatal("endpoints given in wrong order.");

	/* Convert positions in the first sequence to column numbers. */
	for (j = k = 0; j < ncol; ++j)
		if (isalpha(A[0][j])) {
			if (++k == f)
				from = j;
			if (k == t){
				to = j;
				break;
			}
		}
	if (j == ncol)
		fatal("Column index is out of range.");

	for (i = 0; i < nrow; ++i) {
		for (j = from; j <= to; ++j)
			putchar(A[i][j]);
		printf("  %s\n", seq_name[i]);
	}
	
	return 0;
}
