/* piplib.c -- various utility routines specific to PipMaker */

#include "util.h"
#include "piplib.h"

static const char rcsid[]=
"$Id: piplib.c,v 1.3 2001/05/23 00:35:07 schwartz Exp $";

static const char Tag[] =
"/x-axis-label () def\n\
/y-axis-label () def\n\n\
0 setrow\n";

void tag_header(void)
{
	printf(Tag);
}

static int is_space(int ch)
{
    return isascii(ch) && isspace(ch);
}

/* Destructively modify a string so that the contents can be 
 * safely treated as a postscript string. */
void quote_for_ps(char *s)
{
    /* Strings in postscript are delimited by (), not "". */
    /* XXX - instead of really quoting, we'll just replace some things. */
    if (s == NULL)
	fatal("quote_for_ps was handed a null pointer.");
    for (; *s; ++s) {
	if (*s == '(') *s = '[';
	if (*s == ')') *s = ']';
	if (*s == '\\') *s = '/';
	if (is_space(*s)) *s = ' ';
    }
}
