/* clip_tag.c -- clip tags in a tag file */

#include "util.h"

enum { BUF_SIZE=500 };

int main(int argc, char **argv)
{
	char buf[BUF_SIZE], *p;
	int left_bound, right_bound, from, to;
	FILE *fp;

	argv0 = "clip_tag";
	if (argc != 4)
		fatal("args = tag-file left-bound right_bound");

	fp = ckopen(argv[1], "r");

	left_bound = atoi(argv[2]);
	right_bound = atoi(argv[3]);
	/*
	if (left_bound < 0 || left_bound > right_bound)
		fatalf("improper bounds in command line.");
	*/

	while (fgets(buf, BUF_SIZE, fp)) {
		if (buf[0] == '%')
			continue;
		for (p = buf; *p == ' '; ++p)
			;
		if (strstr(p, " Gene") != NULL) {
			if (sscanf(p, "%d %d", &from, &to) != 2)
				fatalf("%s: conversion failure.", buf);
			while (isdigit(*p))
				++p;
			while (*p != '\0' && !isdigit(*p))
				++p;
			while (isdigit(*p))
				++p;
			if (from < left_bound)
				from = left_bound;
			if (to > right_bound)
				to = right_bound;
			if (to >= left_bound && from <= right_bound)
				printf("%d %d%s", from, to, p);
			continue;
		} else if ((p[0] == '-' || isdigit(*p))
		    && !strstr(p, "setrow")) {
			if (sscanf(p, "%d %d", &from, &to) != 2)
				fatalf("conversion failure.");
			if (to < left_bound || from > right_bound)
				continue;
		}
		printf("%s", buf);
	}
	fclose(fp);
	return 0;
}
