/* -- print user-friendly form of a blastz alignment */

#include "util.h"
#include "lav.h"

#define REV   " (reverse complement)"

enum { BUF_SIZE=1000 };

int main(int argc, char **argv)
{
	char buf[BUF_SIZE], buf2[BUF_SIZE];
	char *p;
	int from1, from2, to1, to2, len, pct, reverse = 0,
	    seq1begin, seq1end, seq2begin, seq2end;
	FILE *fp;

	argv0 = argv[0];
	if (argc != 2)
		fatal("arg = blastz-output");

	fp = alignopen(argv[1]);

	while (fgets(buf, BUF_SIZE, fp))
		if (strcmp(buf, "s {\n") == 0) {
			fgets(buf, BUF_SIZE, fp);
			if (sscanf(buf+2, "%s %d %d", buf2, &seq1begin, &seq1end)!=3)
				fatal("Cannot parse sequence endpoints");
			fgets(buf, BUF_SIZE, fp);
			if (sscanf(buf+2, "%s %d %d", buf2, &seq2begin, &seq2end)!=3)
				fatal("Cannot parse sequence endpoints");
			reverse = isrevcomp(NULL, buf2);
		} else if (strcmp(buf, "h {\n") == 0) {
			lav_contigname(fp, buf, BUF_SIZE, buf2);
			if ((p = strstr(buf2, REV)))
				*p = '\0';
			printf("\n\nAligned to \"%s\"%s:\n", buf2, (p ? REV : ""));
		} else if (strcmp(buf, "a {\n") == 0)
			printf(":\n");
		else if (strncmp(buf, "  l ", 4) == 0) {
			if (sscanf(buf+4, "%d %d %d %d %d",
			    &from1, &from2, &to1, &to2, &pct) != 5)
				fatalf("Cannot parse line: %s", buf);
			len = to1 - from1 + 1;

			/* convert to user coordinates */
			from1 += seq1begin - 1;
			to1   += seq1begin - 1;
			if (reverse) {
				from2 = seq2end + 1 - from2;
				to2   = seq2end + 1 - to2;
			}
			else {
				from2 += seq2begin - 1;
				to2   += seq2begin - 1;
			}

			printf("%d-%d <--> %d-%d %d%% (%d nt)\n",
			    from1, to1, from2, to2, pct, len);
		}
	return 0;
}
