#!/bin/sh
# $Id: mkdotplot.sh,v 1.7 2003/06/11 20:02:05 schwartz Exp $

USAGE='usage: mkdotplot align.lav exons [underlays] [ulib]'
LAV=${1:?$USAGE}
EXONS=${2:?$USAGE}
UNDER=${3:-/dev/null}
ULIB=${4:-/dev/null}

# XXX - right now laps needs the alignment to be seekable
DOT=mkdotplot.$$

dotprep ${LAV} > ${DOT} &&
dothoriz ${LAV} > ${DOT}.tag &&
dottag1 ${EXONS} ${LAV} > ${DOT}.htag &&
dottag2 ${LAV} > ${DOT}.vtag &&
laps \
	${DOT} \
	-utag ${ULIB} \
	-utag ${UNDER} \
	-tag  ${DOT}.tag \
	-htag ${DOT}.htag \
	-vtag ${DOT}.vtag \
        -dot -nb -nc -ht=99999999 -vt=99999999 \
        -ticfontsize=11 -labelfontsize=11 -bannerfontsize=13 &&
rm -f ${DOT} ${DOT}.tag ${DOT}.htag ${DOT}.vtag
