/* $Revision: 1.9 $$Date: 2001/03/21 19:28:55 $ */

#ifndef PIPLIB_LAV
#define PIPLIB_LAV

#include "util.h"

typedef struct segment {
	int x0, x1;    /* endpoints in first sequence (s/a/l)           */
	int y0, y1;    /* endpoints in second sequence (s/a/l)          */
	int score;     /* score or percent identity (a/l)               */
	int nth;       /* nth contig in seq2 (s)			*/
	int nlav;      /* nth lav run in output				*/
	char *hdr2;    /* contig header from second sequence (s only)   */
	bool reverse;  /* is contig aligned in reverse comp? (s/a/l)    */
	char type;     /* 's' = contig block, 'a' = local alignment,
	                  'l' = gap-free segment, 'z' = end marker      */
} Segment;

int get_align (char *filename, Segment **seg);
void free_align (Segment *seg, int size);
int find_seg (Segment *seg, int pos, bool inseq2, char *contig,
              int from_index, bool *gap);
int convert_pos (Segment *seg, int i, int pos, bool inverse, bool gap);
bool seg_overlaps (Segment *seg, int i, int start, int end, bool inseq2);
bool has_multi_contig (Segment *seg);
char *get_hdr2 (Segment *seg, int i);
bool same_local (Segment *seg, int i1, int i2);
void get_seqparams (char *buf, int *, int *, int *, int *);
#endif
