#include "util.h"
#include <signal.h>

#ifndef __lint
static const char rcsid[] =
"$Id: signal-dflt.c,v 1.1 2001/04/23 18:51:35 webb Exp $";
#endif

/* Cron (at least on solaris) likes to ignore some signals
   that we need to catch, and ksh (at least on solaris)
   won't let you catch signals that start out ignored.
   So we unignore them with this. */

int main(int argc, char **argv)
{
    if (signal(SIGXCPU, SIG_DFL) == SIG_ERR)
	fatal("signal: XCPU");
    if (signal(SIGXFSZ, SIG_DFL) == SIG_ERR)
	fatal("signal: XFSZ");

    if (argc > 0)
        execvp(argv[1], argv+1);
    return 1;
}
