/* underlay_noseq - prepare underlay file to show regions that may lack
* sequence data in the second species.
*/

#include "util.h"
#include "lav.h"

#define MIN_LEN 100	/* discard shorter alignments */

int main(int argc, char **argv)
{
	int seq_len, x, y, lo, hi;
	char buf[500];
	FILE *fp;


	argv0 = "underlay_noseq";
	if (argc != 2)
		fatal("args = blastz-output");

	seq_len = seq1len(argv[1]);
	printf("1 %d LightGray\n", seq_len);
	fp = ckopen(argv[1], "r");
	if (fgets(buf, 500, fp) == NULL || !same_string(buf, "#:lav\n") )
		fatalf("%s is not an lav-format file.", argv[1]);
	lo = seq_len;
	hi = 0;
	while (fgets(buf, 500, fp))
		if ( same_string(buf, "s {\n") ) { // was #:lav
			if (lo < seq_len)
				printf("%d %d White\n", lo, hi);
			lo = seq_len;
			hi = 0;
		} else if (same_string(buf, "a {\n")) {
			fgets(buf, 500, fp); /* score */
			fgets(buf, 500, fp);
			if (sscanf(buf, "  b %d %*d", &x) != 1)
				fatalf("begin: %s", buf);
			fgets(buf, 500, fp);
			if (sscanf(buf, "  e %d %*d", &y) != 1)
				fatalf("end: %s", buf);
			if (y - x + 1 >= MIN_LEN) {
				lo = MIN(lo, x);
				hi = MAX(hi, y);
			}
		}
	if (lo < seq_len)
		printf("%d %d White\n", lo, hi);

	fclose(fp);

	return 0;
}
