#!/usr/local/bin/perl -w
# $Id: mkunderlays.pl,v 1.12 2001/02/12 22:03:20 schwartz Exp schwartz $

# Blue EST
# 0  10 Green 
# 20 50 EST

use warnings;
use strict;

# input format:
#  \w \w
#  \d \d \w

my @colors = (
    "Black",
    "White", 
    "Gray", "LightGray", "DarkGray", 
    "Red", "LightRed", "DarkRed", 
    "Green", "LightGreen", "DarkGreen", 
    "Blue", "LightBlue", "DarkBlue", 
    "Yellow", "LightYellow", "DarkYellow", 
    "Pink", "LightPink", "DarkPink",
    "Cyan",  "LightCyan", "DarkCyan",
    "Purple", "LightPurple", "DarkPurple", 
    "Orange", "LightOrange", "DarkOrange", 
);

my %alias;

sub check_color
{
    my $c = shift;
    $c = "" unless defined $c;
    die "$0: Bad color '$c' at line $.\n" 
	unless grep(/^\Q$c\E$/, @colors);
}

print "% mkunderlays\n";
# This should probably go in the prolog
# print "/Colorized_Regions {\n";
while (<>) {
    chomp;
    s/#.*//;
    next if (/^$/); 
    if (/^\s*(\d+)\s*(\d+)\s*(\w+)\s*([+-])?/) {
	# 0 10 Green +
	my($x0,$x1,$c,$r) = ($1, $2, $3, $4);
	#print "{$x0} {$x1} {$c} {$r}\n";

	$r = "" unless defined($r);
	if ($r eq "+") {
	    $r = "UnderlayRectTopHalf";
        } elsif ($r eq "-") {
	    $r = "UnderlayRectBottomHalf";
        } else {
	    $r = "UnderlayRect";
        }

	#print "c{$c} alias{$alias{$c}}\n";
	$c = ($alias{$c} || $c);
	check_color $c;
        print "$x0 $x1 $c $r\n";
    } elsif (/^\s*(\w+)\s+(\w+)/) {
	# Blue EST
	#print "c{$1} n{$2}\n";
	check_color $1;
	$alias{$2} = $1;
	print "%c $1 $2\n";
    } else {
            die "$0: Bad input line '$_' at line $.\n";
    }
}
# print "} def\n";

# This should probably go in the tags
# print "Colorized_Regions\n";

