#!/bin/sh
# $Id: pipmaker.sh,v 1.22 2003/06/11 21:08:49 schwartz Exp $

#
# Make a pip, given a directory containing data files.
#
PIPSPOOL=${PIPHOME:?}/spool
sendmail=/usr/lib/sendmail

case "$1" in
"") exit 1;;
*) ;;
esac

# XXX - configure
vlim=`expr 900 \* 1024`;   # MB (XXX - blastz always allocs 800MB now)
tlim=`expr 30 \* 60`;     # minutes
flim=`expr 80 \* 1024`;   # MB

umask 0002
ulimit -c 0

dir=`basename $1`
dir="${dir:?}"
workdir="$PIPSPOOL/work/$dir"
trash="$PIPSPOOL/trash"
errdir="$PIPSPOOL/err"

cd "$workdir" || exit 1

# For logging:
#echo job: $dir
#cat dump # parameters

if fgrep -i -f $PIPHOME/etc/noquota ./email >/dev/null
then : > ./noquota;
else
    ulimit -t $tlim
    ulimit -f $flim
    # ulimit -v $vlim
fi

if   [ -f 'app=mpip' ]; then app=dompip
elif [ -f 'app=pip3' ]; then app=dopip3
elif [ -f 'app=pip' ];  then app=dopip
else app=dopip
fi

# XXX - security, sorta
touch "$trash/index.html"

if signal-dflt $app >OUT 2>ERR
then
    $sendmail -t < OUT
    cd "$PIPSPOOL" && mv "$workdir" "$trash"
else
    $sendmail -t < ERR

    echo "$errdir/$dir"
    echo
    cat ERR
    echo
    cat id

    cd "$PIPSPOOL" && mv "$workdir" "$errdir"
fi

